# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class AddedImage(pydantic.BaseModel):
    """
    Confirmation of an image added to the dataset
    """

    coactive_image_id: str = pydantic.Field(alias="coactiveImageId", description="The coactive image id")
    path: str = pydantic.Field(description="The original path of the image")
    id: typing.Optional[str] = pydantic.Field(description="The user provided image id")
    metadata: typing.Optional[typing.Dict[str, typing.Any]] = pydantic.Field(
        description="The user provided metadata for the image"
    )
    created_dt: dt.datetime = pydantic.Field(alias="createdDt", description="The created timestamp of the image")
    created_user_id: str = pydantic.Field(alias="createdUserId", description="The user that created the image")
    updated_dt: dt.datetime = pydantic.Field(alias="updatedDt", description="The last updated timestamp of the image")
    updated_user_id: str = pydantic.Field(alias="updatedUserId", description="The user that last updated the image")
    request_id: str = pydantic.Field(
        alias="requestId", description="Unique request id for adding this asset to the pipeline"
    )
    request_dt: dt.datetime = pydantic.Field(alias="requestDt", description="Time the request was received")

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
